<template>
	<v-navigation-drawer 
        class="pl-lg-10 px-3 pb-3" 
        app 
        mobile-breakpoint="0"
        :mini-variant="$vuetify.breakpoint.mdAndDown" 
        mini-variant-width="75"
        width="300"
    >
        <div class="d-flex flex-column justify-space-between" style="height:100%">
            <div>
                <v-list>
                    <!-- twitter icon -->
                    <LinkSideNav :title="$vuetify.breakpoint.mdAndDown ? 'Twitter' : undefined" icon="mdi-twitter" rounded="rounded-circle" iconColor="primary" />
                    <!-- list links -->
                    <LinkSideNav v-for="item in navItems" :navItem="item" :key="item.title" />
                    <!-- more link button -->
                    <v-menu top>
                        <template v-slot:activator="{ on, attrs }">
                            <!-- more button -->
                            <LinkSideNav 
                                :bind="attrs"
                                :vOn="on"
                                icon="mdi-dots-horizontal-circle-outline"
                                title="More"
                            />
                        </template>
                        <!-- links on more -->
                        <v-list>
                            <v-list-item v-for="link in moreLinks" :key="link.title">
                                <!-- icon link -->
                                <v-list-item-icon class="py-1 my-2">
                                    <v-icon size="28">
                                        {{ link.icon }}
                                    </v-icon>
                                </v-list-item-icon>
                                <!-- title link -->
                                <v-list-item-content class="pa-0">
                                    <v-list-item-title>
                                        {{ link.title }}
                                    </v-list-item-title>
                                </v-list-item-content>
                            </v-list-item>
                        </v-list>
                    </v-menu>
                    
                </v-list>
                <!-- new tweet button -->
                <DialogNewTweet @newTweetBtn="$emit('newTweetBtn')">
                    <v-btn width="100%" class="primary" small :class="$vuetify.breakpoint.mdAndDown ? 'py-6 rounded-circle' : 'py-6 rounded-pill'" depressed>
                        <v-icon small v-if="$vuetify.breakpoint.mdAndDown">mdi-plus-box</v-icon>
                        <span v-else>Tweet</span>
                    </v-btn>
                </DialogNewTweet>
            </div>
            <!-- profile -->
           <div class="profile">
                <v-menu top content-class="rounded-lg" nudge-top="25">
                    <template v-slot:activator="{ on, attrs }">
                        <v-hover v-slot="{ hover }">
                            <ProfileSideNav :hover="hover" :on="on" :bind="attrs" :profile="profile" sideIcon="mdi-dots-horizontal" />
                        </v-hover>
                    </template>
                    <v-list>
                        <v-list-item>
                            <ProfileSideNav :profile="profile" sideIcon="mdi-check" sideIconColor="primary" />
                        </v-list-item>
                        <v-divider></v-divider>
                        <v-list-item v-for="more in profile.moreProfile" :key="more.title">
                            <v-list-item-title>{{ more.title }}</v-list-item-title>
                        </v-list-item>
                    </v-list>
                </v-menu>
           </div>
        </div>
	</v-navigation-drawer>
</template>

<script>
import ProfileSideNav from "./ProfileSideNav.vue"
import LinkSideNav from "./LinkSideNav.vue"
import DialogNewTweet from './DialogNewTweet.vue';

export default {
    components: {
        ProfileSideNav,
        LinkSideNav,
        DialogNewTweet,
    },
	data() {
		return {
            profile: {
                name: "Twitter",
                username: "@twitter",
                avatar: "T",
                moreProfile: [
                    { title: "Add an existing account" },
                    { title: "Log out @twitter" }
                ],
            },
			navItems: [
				{
					title: "Home",
					icon: "mdi-home-outline",
					iconActive: "mdi-home",
                    notifications: true,
                    notificationsMessage: null,
                    hideSmallDevice: false,
				},
				{
					title: "Explore",
					icon: "mdi-pound",
					iconActive: "mdi-pound",
                    iconMobile: "mdi-magnify",
                    notifications: null,
                    notificationsMessage: null,
                    hideSmallDevice: false,
				},
				{
					title: "Notifications",
					icon: "mdi-bell-outline",
					iconActive: "mdi-bell",
                    notifications: true,
                    notificationsMessage: 1,
                    hideSmallDevice: false,
				},
				{
					title: "Messages",
					icon: "mdi-email-outline",
					iconActive: "mdi-email",
                    notifications: null,
                    notificationsMessage: null,
                    hideSmallDevice: true,
				},
				{
					title: "Bookmarks",
					icon: "mdi-bookmark-outline",
					iconActive: "mdi-bookmark",
                    notifications: null,
                    notificationsMessage: null,
                    hideSmallDevice: true,
				},
				{
					title: "Lists",
					icon: "mdi-view-list-outline",
					iconActive: "mdi-view-list",
                    notifications: null,
                    notificationsMessage: null,
                    hideSmallDevice: false,
				},
				{
					title: "Profile",
					icon: "mdi-account-outline",
					iconActive: "mdi-account",
                    notifications: null,
                    notificationsMessage: null,
                    hideSmallDevice: false,
				},
			],
            moreLinks: [
                { title: "Messages", icon: "mdi-email-outline", showHigherDevice: false, },
                { title: "Bookmark", icon: "mdi-bookmark-outline", showHigherDevice: false, },
                { title: "Topics", icon: "mdi-chat-processing-outline", showHigherDevice: true, },
                { title: "Moments", icon: "mdi-lightning-bolt-outline", showHigherDevice: true, },
                { title: "Newsletters", icon: "mdi-newspaper-variant-outline", showHigherDevice: true, },
                { title: "Twitter Ads", icon: "mdi-arrow-up-bold-box-outline", showHigherDevice: true, },
                { title: "Analytics", icon: "mdi-google-analytics", showHigherDevice: true, },
                { title: "Setting and privacy", icon: "mdi-cog-outline", showHigherDevice: true, },
                { title: "Help Center", icon: "mdi-help-circle-outline", showHigherDevice: true, },
                { title: "Display", icon: "mdi-brush", showHigherDevice: true, },
                { title: "Keyboard shortcuts", icon: "mdi-human", showHigherDevice: true, },
            ]
		};
	},
};
</script>

<style scope>
.v-list-item {
	cursor: pointer;
    max-width: max-content;
}
.v-list-item__icon {
    min-width: unset !important;
}
</style>